=== debian/changelog ===
magics++ (2.24.7-7) unstable; urgency=medium

  * ABI transition needed for libstdc++ v5, to libmagplus3v5. 
    Closes: #797981. 
  * Add Breaks/Replaces libmagplus3

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 11 Sep 2015 11:52:41 +0100

magics++ (2.24.7-6) unstable; urgency=medium

  * Add dependency on libnetcdf-cxx-legacy-dev.
  * Replace B-D libgd2-dev -> libgd-dev

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 14 Aug 2015 09:53:25 +0100

magics++ (2.24.7-5) unstable; urgency=medium

  * Rebuild against libterralib3 for terralib, g++5 transitions.
  * Undo the netcdf transition for the moment
  * Move Qt4 -> Qt5 

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 07 Aug 2015 13:28:04 +0100

magics++ (2.24.7-4) experimental; urgency=medium

  * Build against new netcdf (4.4.0). Closes: #793882.

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 28 Jul 2015 13:32:09 +0100

magics++ (2.24.7-3) experimental; urgency=medium

  * Build against new netcdf (4.4.0). Closes: #793882.

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 28 Jul 2015 13:32:09 +0100

magics++ (2.24.7-2) unstable; urgency=medium

  * Drop timestamps from headers. Closes: #792824. 
  * Add magics++ to dependencies for libmagics++-dev, add metgramx etc
    as required by magics-config.cmake for metview
  * Undo fixes from debian/rules for previously broken builds in 2.24.4
  * Move cmake files to /usr/lib/$ARCH/cmake as arch-dependent,
    and adjust paths in cmake files vi debian/rules

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 22 Jul 2015 19:36:10 +0100

magics++ (2.24.7-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 16 Jul 2015 08:55:06 +0100

magics++ (2.24.4-2) experimental; urgency=medium

  * Test Build against netcdf 4.4.3 in experimental 

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 15 Jul 2015 16:48:32 +0100
